/*

Name:
DRV_BE.C

Portability:
Only BeBox system

*/

#include "bemain.h"

BAudioSubscriber *auds=NULL;

BOOL BE_IsThere(void)
{
	return 1;
}

void BE_Exit(void)
{
}

bool _be_play_back(void *arg, char *sound, long size)
{
	if(!MP_Ready())
	{
		VC_WriteBytes(sound,size);
		return(TRUE); 
	}
	else return(FALSE);
}

void BE_PlayStop(void)
{
	auds->ExitStream(TRUE);
	auds->Unsubscribe();
}

void BE_Update(void)
{
	if(!(!auds->Subscribe(B_DAC_STREAM, B_SHARED_SUBSCRIBER_ID,FALSE) < B_NO_ERROR));
	{
		auds->SetSamplingRate(md_mixfreq);
		auds->SetDACSampleInfo(
			md_mode & DMODE_16BITS ? 2 : 1,
    		md_mode & DMODE_STEREO ? 2 : 1,
       		B_BIG_ENDIAN,
       		B_LINEAR_SAMPLES
		);
		auds->SetStreamBuffers(md_dmabufsize, 8);
		auds->EnterStream
		(
			NULL, 		
       		TRUE, 		
       		NULL, 		
       		_be_play_back, 
       		NULL, 		
       		TRUE  		
		);
	}
}

DRIVER drv_be={
	NULL,
	"\033[1;4;34mB\033[1;4;31me\033[0;30m Sound by Tinic Urou",
	"BeBox Sounddriver by Tinic Urou in 1996",
	BE_IsThere,
	VC_SampleLoad,
	VC_SampleUnload,
	VC_Init,
	BE_Exit,
	VC_PlayStart,
	BE_PlayStop,
	BE_Update,
	VC_VoiceSetVolume,
	VC_VoiceSetFrequency,
	VC_VoiceSetPanning,
	VC_VoicePlay
};
